function Graph=ConvertFormat(x,y,z)

[FileName,PathName] = uigetfile('*.*','*.*');

fileID = fopen([PathName,FileName],'r');
xT1=textscan(fileID,'%s','whitespace','\n');
fclose(fileID);
xT1=xT1{1,1};

for i=1:length(xT1)
    now=xT1{i,1};
    sps=find(now==' ');
    sps=[0,sps,length(now)+1];
    for j=1:length(sps)-1
        all(i,j)=str2double(now(sps(j)+1:sps(j+1)-1));
    end
end

sz=size(all,1);
G=zeros(sz,sz);
Graph.nd=all(:,2:4);
br=[];
for i=1:sz
    if Graph.nd(i,1)<=x&&Graph.nd(i,2)<=y&&Graph.nd(i,3)<=z
        for j=1:all(i,5)
            G(i,all(i,5+j))=1;
            G(all(i,5+j),i)=1;
        end
    else
        br=[br,i];
    end
end

Graph.nd(br,:)=[];
G(br,:)=[];
G(:,br)=[];

G=triu(G,1);
[first,last]=find(G);
T2=[first,last];%   T2        .

Graph.ed=T2;

Graph.String=['from_file_',FileName,'_',num2str(x),'_',num2str(y),'_',num2str(z)];
Graph.xyz=[max(Graph.nd(:,1)),max(Graph.nd(:,2)),max(Graph.nd(:,3))];

save([Graph.String,'.mat'],'Graph');

