%% function for create graph with specified distribution
function Graph=WineRack(nLen,nH,nW,Len,H,W)

% close all;
tic
%calculate sizes
Nxy=(nLen*nH*2+nLen+nH);
N=Nxy*(nW+1);
%create table of nodes links
TabLink=zeros(N,N);
%calculate sizes
L1=Len/nLen;
H1=H/nH;
W1=W/nW;

% 
% 
% coord01=0:Len/nLen:Len;
coord1=[];
coord2=[];
coord3=[];

coord01=[];
coord02=[];
% 
for i=1:nH*2+1
    if mod(i,2)==1
        coord01=[coord01,L1/2:L1:Len];
        coord02=[coord02,ones(1,nLen)*H1/2*(i-1)];
    else
        coord01=[coord01,0:L1:Len];
        coord02=[coord02,ones(1,nLen+1)*H1/2*(i-1)];
    end
end

% 3-    
for i=1:nW+1
    coord3=[coord3,ones(1,Nxy)*W1*(i-1)];
    coord2=[coord2,coord02];
    coord1=[coord1,coord01];
end

%  ,     ,
%  
for i=1:Nxy
    for j=1:Nxy
        if (sqrt((coord1(i)-coord1(j))^2+(coord2(i)-coord2(j))^2)-(sqrt(H1^2+L1^2)/2))/(sqrt(H1^2+L1^2)/2)<0.01&&coord1(i)~=coord1(j)&&coord2(i)~=coord2(j)
            TabLink(i,j)=1;
        end
    end
end
            
        


% 
[xx,yy]=find(TabLink);
% 
% % yy2=[yy;max(yy)+1];
%  

yy2=yy;
for i=1:length(xx)
    for j=1:nW
        TabLink(yy2(i)+(j-1)*Nxy,yy2(i)+j*Nxy)=1;
        TabLink(yy2(i)+j*Nxy,yy2(i)+(j-1)*Nxy)=1;
    end
end
% 
for i=1:nW+1
    for j=1:length(xx)
        TabLink(xx(j)+(i-1)*Nxy,yy(j)+(i-1)*Nxy)=1;
        TabLink(yy(j)+(i-1)*Nxy,xx(j)+(i-1)*Nxy)=1;
    end
end


% plot3(coord1,coord2,coord3,'o');

% for i=1:

%   

    G =TabLink;
    G=triu(G,1);
    [first,last]=find(G);
    T2=[first,last];
        
all=[coord1',coord2',coord3'];
Graph.nd=all;
Graph.ed=T2;
% Graph.RL=[Rad,Len];
% Graph.ni=NumIntLen;
Graph.vr1=[nLen,nH,nW,Len,H,W];





DateString=datestr(clock);
DateString(DateString==':')='_';
DateString(end-8:end)=[];
DateString=['WR_',num2str(nLen),'_',num2str(nH),'_',num2str(nW),'_',num2str(Len),'_',num2str(H),'_',num2str(W)];
Graph.String=DateString;
save([DateString,'.mat'],'Graph');
toc
% (ro,a,expmu,sigma,MaxDeg,Rad,Len)


